% Rudiger̐ɊÂӕϒ̎Zo
function BO_surround_model(n)
dataFolderPath = 'data/';

%% surround
load S300;
surroundStructArray = S300(n);
nSurroundStruct = size(surroundStructArray, 2);

clear surround;
surround = arrayfun(@surroundFilter, surroundStructArray);

%% gabor
Ksize = 21;
phase = pi/2;
wavelengthArray = [5, 5.923, 7.017, 8.314, 9.848, 11.667];
nWavelength = size(wavelengthArray, 2);
nOrienation = 8;
gaborFilter(1:nWavelength, nOrienation) = struct('Kernel', []);
for o = 1 : nOrienation,
    %g7
    gaborFilter(1, o).Kernel = gabor(Ksize, wavelengthArray(1), 1.5, 1.2, (o-1)*pi/4, phase);
    %g5.909
    gaborFilter(2, o).Kernel = gabor(Ksize, wavelengthArray(2), 1.6, 1.4, (o-1)*pi/4, phase);
    %g4.988
    gaborFilter(3, o).Kernel = gabor(Ksize, wavelengthArray(3), 2.0, 1.7, (o-1)*pi/4, phase);
    %g4.201
    gaborFilter(4, o).Kernel = gabor(Ksize, wavelengthArray(4), 2.5, 2.0, (o-1)*pi/4, phase);
    %g3.554
    gaborFilter(5, o).Kernel = gabor(Ksize, wavelengthArray(5), 4.0, 3.5, (o-1)*pi/4, phase);
    %g3
    gaborFilter(6, o).Kernel = gabor(Ksize, wavelengthArray(6), 4.5, 4.0, (o-1)*pi/4, phase);
end

% h̐ݒ
ppd = 35; % 1 degrees = ppd pixels
sizedeg = 3;
B = 127;
F = 255;
sideArray = ['l';'r'];
typeArray = ['10000000';'11000000';'10100000';'10010000';...
    '10001000';'10000100';'10000010';'10000001';'11111111'];

for iSide = 1 : size(sideArray, 1)
    for jType = 1 : size(typeArray, 1)
        [grayImage, bmap] = stimulus(sizedeg, B, F, sideArray(iSide), ppd, typeArray(jType, :));

       %% RgXgo
        % V1זE̎e͕킵GabortB^pPxRgXǧo
        contrast = gaborFiltering(grayImage, gaborFilter);

        % g̓
        cs = cell(1, nOrienation); % cs̎O蓖
        for o = 1 : nOrienation,
            cs{o} = 1.2 .* contrast(1, o).normcont+...
                1.5 .* contrast(2, o).normcont+...
                1.8 .* contrast(3, o).normcont+...
                2.0 .* contrast(4, o).normcont+...
                1.5 .* contrast(5, o).normcont+...
                1.2 .* contrast(6, o).normcont;
            cs{o} = (1/9.2) .* cs{o};
        end

       %% Surround Effect Stage
        [iso, cross] = separateOrientation(cs);

        % CRF
        g = gabor(Ksize,10,5,5,0,0);
        HMiso = filter2(g, bmap);
        HMiso(find(HMiso<0)) = 0;
        HMiso = HMiso ./ max(max(HMiso));

        % convolution and BO activity
        [BO,surround] = calcSurroundEffectAndBOonHM(surround,...
            iso,cross,HMiso,nSurroundStruct);
        
        filePath = strcat(dataFolderPath, sideArray(iSide), typeArray(jType, :), '.mat');
        save(filePath,'BO','grayImage');
    end
end

%% rudiger_response.m ̌ʂ͉摜AӕϒʂƂBȌo͂
for n = 1 : nSurroundStruct
    BOResponseArray = zeros(size(sideArray, 1)*size(typeArray, 1), 1);
    
    % center only
    load(strcat(dataFolderPath, 'r10000000.mat'),'BO');
    BOCR = BO;
    % CRFW
    crfx = (size(grayImage,2)+1)/2;
    crfy = (size(grayImage,1)+1)/2;
    
    for iSide = 1 : size(sideArray, 1)
        for jType = 1 : size(typeArray, 1)
            load(strcat(dataFolderPath, sideArray(iSide), typeArray(jType, :), '.mat'), 'BO');
            % r10000000łactƂČ
            BOResponseArray((iSide-1)*size(typeArray, 1) + jType) = BO(n).act(crfy, crfx) - BOCR(n).act(crfy, crfx);
        end
    end
    
    % ͉摜\
    typeLabel = {'NC1','NC2','NE1','NE2','FC1','FC2','FE','All'};
    for iSide = 1 : size(sideArray, 1)
        for jType = 1 : size(typeArray, 1)-1
            load(strcat(dataFolderPath, sideArray(iSide), typeArray(jType+1, :), '.mat'), 'grayImage');
            figure(iSide);
            subplot(4,2,jType);
            imshow(grayImage, []);
            title(strcat(sideArray(iSide), typeArray(jType+1, :), '(', typeLabel(jType), ')'));
        end
    end
    
    figure(n+2);
    subplot(2,2,1);
    imagesc(surround(n).excitatory);
    title('excitatory');
    subplot(2,2,2);
    imagesc(surround(n).inhibitory);
    title('inhibitory');
    subplot(2,2,[3,4]);
    bar(BOResponseArray);
    ax = gca;
    ax.XTick = 1:18;
    % ꂼ͉摜̎lp`̂ǂ̕\Ă邩ɑΉ
    ax.XTickLabel = {'CE','NC1','NC2','NE1','NE2','FC1','FC2','FE','All','CE','NC1','NC2','NE1','NE2','FC1','FC2','FE','All'};
    title('left side                                                                        right side');
%     saveas(fig, strcat('surround', num2str(n), '.eps'), 'epsc');
end
end

function g = gabor(Ksize, wavelength, height, width, tilt, phase)
% 1̃K{[tB^̍쐬
% [INPUT]
%  Ksize --- J[l̑傫(`̃tB^̂P)@]܂
%  wavelength --- g[pizel]
%  height, width --- Gaussian1SD̍ƕ
%  tilt --- GaussiaňX[radian]
%  phase --- g̈ʑ[radian]
% [OUTPUT]
%  g --- 쐬ꂽK{[tB^
% 
% Satoshi Watanabe
% Feb. 2008

rx = (Ksize-1)/2;ry = (Ksize-1)/2;
[X, Y] = meshgrid([0:Ksize-1], [0:Ksize-1]);

Zx = (X-rx) .* cos(tilt) - (Y-ry) .* sin(tilt);
Zy = (X-rx) .* sin(tilt) + (Y-ry) .* cos(tilt); 
Ex = exp(-(Zx.^2)./(width^2));
Ey = exp(-(Zy.^2)./(height^2)); 
E = Ex .* Ey;

G = (1/2*pi) .* cos( (2*pi/wavelength) .* (Zx) + phase ) .* E;
g = G./max(max(G));
end

function surround = surroundFilter(surroundStruct)
% ӕϔɂẴf[^ӕϒtB^쐬
% [INPUT]
% surroundStruct --- ӕϔɂẴf[^
% [OUTPUT]
% surround.inhibitory --- }̎ӕϒtB^
%         .excitatory --- ̎ӕϒtB^
%         .r          --- ӕϒ̍L

range = 360;

surround.inhibitory = makeFilter(surroundStruct.iso.x, surroundStruct.iso.y, surroundStruct.iso.l, surroundStruct.iso.w, range);
surround.excitatory = makeFilter(surroundStruct.cross.x, surroundStruct.cross.y, surroundStruct.cross.l, surroundStruct.cross.w, range);
surround.r = surroundStruct.r;
end

function Z = makeFilter(x, y, length, width, range)
% ʒu֌Ŵ܂܂ɂĎӕϒtB^쐬
% surrounding connection̋Ƃ̍LGaussianzpĒ`
% x, y --- ̒_x^ÿʒu
% width, length --- Gaussianx^ył1SD

% tB^̒S_
fx = range/2;
fy = range/2;
% NishimuratB^̒S_xyW
ncenter = 118/2;
x = fx + x - ncenter;
y = fy + y - ncenter;
[X, Y] = meshgrid([0:range], [0:range]);

Zx = exp(-((X-x).^2)./(width^2));
Zy = exp(-((Y-y).^2)./(length^2));
Z = Zx .* Zy;
end

function [grayImage,bmap] = stimulus(sizedeg,B,F,side,ppd,type)
% lp`8ɕāAIɕ\h쐬
% [INPUT]
% sizedegFhTCYidegreej
% BFwiF
% FF}̐F
% sideF}̕iCRFEirjoriljj
% typeF['10000000';'11000000';'10100000';'10010000';'10001000';...
%           '10000100';'10000010';'10000001';'11111111'];
% type̍A
% 0c\Ȃ
% 1c\
%              near edge 1
% far corner 1@@near corner 1
%             U@S@Q
% @@@@@@@
%     far edgeW@@@Pcenter edge
% @@@@@@@
%             V@T@R
% far corner 2@@near corner 2
%              near edge 2
% 
% [OUTPUT]
% grayImage
% bmap

sizepix = sizedeg*ppd;
halfSizepix = fix(sizepix/2);
quarterSizepix = fix(halfSizepix/2);
rambda = sizepix/24;
margin = sizepix; %c̗]ipixelj

%% Cornsweet figureɂ
C = zeros(1,sizepix);
for c = -halfSizepix:halfSizepix
    C(halfSizepix+c+1) = B+(F-B)*sign(c)*exp(-abs(c)/rambda);
end

%% figure̒S_̍W
centery = margin+halfSizepix+1;
if strcmp(side,'l')
    % BO
    centerx = margin+halfSizepix+1;
else
    % BOE
    centerx = margin+sizepix+halfSizepix;
end

%% 摜̍쐬
grayImage = ones(margin*2+sizepix,margin*2+2*sizepix-1);
grayImage(:,:) = B;
for i=1:sizepix
    grayImage(centery-(sizepix-i):centery+sizepix-i,centerx-(sizepix-i):centerx+sizepix-i) = C(i);
end

bmap = zeros(size(grayImage));
bmap(centery-(halfSizepix):centery+halfSizepix,centerx-(halfSizepix):centerx+halfSizepix) = 1;
bmap(centery-(halfSizepix-1):centery+(halfSizepix-1),centerx-(halfSizepix-1):centerx+(halfSizepix-1)) = 0;

%% h̎
if strcmp(side,'l')
    % BO
    if ~str2num(type(1))
    % delete center edge
    grayImage(centery-quarterSizepix:centery+quarterSizepix,...
        centerx+halfSizepix-quarterSizepix:centerx+halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(2))
    % delete near corner 1
    grayImage(centery-halfSizepix-quarterSizepix:centery-halfSizepix+quarterSizepix,...
        centerx+halfSizepix-quarterSizepix:centerx+halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(3))
    % delete near corner 2
    grayImage(centery+halfSizepix-quarterSizepix:centery+halfSizepix+quarterSizepix,...
        centerx+halfSizepix-quarterSizepix:centerx+halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(4))
    % delete near edge 1
    grayImage(centery-halfSizepix-quarterSizepix:centery-halfSizepix+quarterSizepix,...
        centerx-quarterSizepix:centerx+quarterSizepix) = B;
    end
    if ~str2num(type(5))
    % delete near edge 2
    grayImage(centery+halfSizepix-quarterSizepix:centery+halfSizepix+quarterSizepix,...
        centerx-quarterSizepix:centerx+quarterSizepix) = B;
    end
    if ~str2num(type(6))
    % delete far corner 1
    grayImage(centery-halfSizepix-quarterSizepix:centery-halfSizepix+quarterSizepix,...
        centerx-halfSizepix-quarterSizepix:centerx-halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(7))
    % delete far corner 2
    grayImage(centery+halfSizepix-quarterSizepix:centery+halfSizepix+quarterSizepix,...
        centerx-halfSizepix-quarterSizepix:centerx-halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(8))
    % delete far edge
    grayImage(centery-quarterSizepix:centery+quarterSizepix,...
        centerx-halfSizepix-quarterSizepix:centerx-halfSizepix+quarterSizepix) = B;
    end

else
    % BOE
    if ~str2num(type(1))
    % delete center edge
    grayImage(centery-quarterSizepix:centery+quarterSizepix,...
        centerx-halfSizepix-quarterSizepix:centerx-halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(2))
    % delete near corner 1
    grayImage(centery-halfSizepix-quarterSizepix:centery-halfSizepix+quarterSizepix,...
        centerx-halfSizepix-quarterSizepix:centerx-halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(3))
    % delete near corner 2
    grayImage(centery+halfSizepix-quarterSizepix:centery+halfSizepix+quarterSizepix,...
        centerx-halfSizepix-quarterSizepix:centerx-halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(4))
    % delete near edge 1
    grayImage(centery-halfSizepix-quarterSizepix:centery-halfSizepix+quarterSizepix,...
        centerx-quarterSizepix:centerx+quarterSizepix) = B;
    end
    if ~str2num(type(5))
    % delete near edge 2
    grayImage(centery+halfSizepix-quarterSizepix:centery+halfSizepix+quarterSizepix,...
        centerx-quarterSizepix:centerx+quarterSizepix) = B;
    end
    if ~str2num(type(6))
    % delete far corner 1
    grayImage(centery-halfSizepix-quarterSizepix:centery-halfSizepix+quarterSizepix,...
        centerx+halfSizepix-quarterSizepix:centerx+halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(7))
    % delete far corner 2
    grayImage(centery+halfSizepix-quarterSizepix:centery+halfSizepix+quarterSizepix,...
        centerx+halfSizepix-quarterSizepix:centerx+halfSizepix+quarterSizepix) = B;
    end
    if ~str2num(type(8))
    % delete far edge
    grayImage(centery-quarterSizepix:centery+quarterSizepix,...
        centerx+halfSizepix-quarterSizepix:centerx+halfSizepix+quarterSizepix) = B;
    end
end
end

function contrast = gaborFiltering(grayImage, gaborFilter)
% OCXP[C[WK{[tB^ɂBiPxRgXgoj
% łɁA̒l؂̂ĂāAől10ɃXP[O
% [INPUT]
%  grayImage --- tB^摜ix}bvj
%  gab --- K{[tB^f[^
% [OUTPUT]
%  contrast(f,o).cont --- PɃK{[tB^f[^
%               .normcont --- ̃f[^̒̕l؂̂ĂāAKf[^
%   w,o --- gAʂ̃CfbNX
% 
% Satoshi Watanabe
% Feb. 2008

[nWavelength, nOrienation] = size(gaborFilter);

contrast(1:nWavelength, 1:nOrienation) = struct('cont', [], 'normcont', []);
for w = 1:nWavelength,
    for o = 1:nOrienation,
        %gabggrayImagetB^O
        contrast(w,o).cont = filter2(gaborFilter(w,o).Kernel,grayImage);
        %̒l؂̂
        contrast(w,o).cont(find(contrast(w,o).cont<0))=0;
        %ő劈10ɐK
        contrast(w,o).normcont= (10/(255*sum(gaborFilter(w,o).Kernel(gaborFilter(w,o).Kernel>0)))).* contrast(w,o).cont;
    end
end
end

function [iso, cross] = separateOrientation(cs)
% RgXgf[^𓯕ʐƈٕʐɕ

nOrientation = size(cs, 2);

iso = cell(1, nOrientation/2);
cross = cell(1, nOrientation/2);
for o = 1 : nOrientation/2
    iso{o} = cs{o} + cs{o+nOrientation/2};
    iso{o} = iso{o} ./ max(max(iso{o}));
    
    ori = 1 : nOrientation;
    ori(o+nOrientation/2) = [];
    ori(o) = [];
    
    cross{o} = cs{ori};
    cross{o} = cross{o} ./ max(max(cross{o}));
end
end

function [BO,surround] = calcSurroundEffectAndBOonHM(surround,iso,cross,HMiso,nSurroundStruct)
% oEPxRgXg͌ʂ
% Human Marked ContourBOactivityvZ
% [INPUT]
%  surround --- ͌ʃtB^f[^
%  iso --- oꂽPxRgXg̓ʐ
%  cross --- oEꂽPxRgXgٕ̈ʐ
%  HMiso --- Human Marked Contour̓ʐ
%  nSurroundStruct --- ͌ʃtB^̑
% [OUTPUT]
%  BO(n).act --- ZoꂽBOactivity
%  surround(n).inhibitory --- Zoꂽ}͌
%  surround(n).excitatory --- Zoꂽ͌
% 
% Satoshi Watanabe
% Feb. 2008

kact = 0.1;

% normalizegꍇi]@j
for n=1:nSurroundStruct
    kinh=1/sum(sum(surround(n).inhibitory));
    kexc=1/sum(sum(surround(n).excitatory));
    surround(n).inh = kinh...
                .* filter2(surround(n).inhibitory,iso{n});
    surround(n).exc = kexc...
                .* filter2(surround(n).excitatory,cross{n});
end

BO(1:nSurroundStruct) = struct('act', []);
for n=1:nSurroundStruct
    BO(n).act = kact .* HMiso...
        .* (HMiso + surround(n).exc - (1.3 .* surround(n).inh));
end
end

